---
title: Intl.Locale.prototype.hourCycle
slug: Web/JavaScript/Reference/Global_Objects/Intl/Locale/hourCycle
tags:
  - Internationalization
  - Intl
  - JavaScript
  - Property
  - Prototype
  - Reference
---
<div>{{JSRef}}</div>

<p>The <strong><code>Intl.Locale.prototype.hourCycle</code></strong> property is an accessor property that returns the time keeping format convention used by the locale.</p>

<h2 id="Description">Description</h2>

<p>There are 2 main types of time keeping conventions (clocks) used around the world: the 12 hour clock and the 24 hour clock. The <code>hourCycle</code> property makes it easier for JavaScript programmers to access the clock type used by a particular locale. Like other additional locale data, hour cycle type is an <a href="https://www.unicode.org/reports/tr35/#u_Extension">extension subtag</a>, which extends the data contained in a locale string. The hour cycle type can have several different values, which are listed in the table below.</p>

<h3 id="Valid_hour_cycle_types">Valid hour cycle types</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Hour cycle type</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>h12</code></td>
   <td>Hour system using 1–12; corresponds to 'h' in patterns. The 12 hour clock, with midnight starting at 12:00 am.</td>
  </tr>
  <tr>
   <td><code>h23</code></td>
   <td>Hour system using 0–23; corresponds to 'H' in patterns. The 24 hour clock, with midnight starting at 0:00.</td>
  </tr>
  <tr>
   <td><code>h11</code></td>
   <td>Hour system using 0–11; corresponds to 'K' in patterns. The 12 hour clock, with midnight starting at 0:00 am.</td>
  </tr>
  <tr>
   <td><code>h24</code></td>
   <td>Hour system using 1–24; corresponds to 'k' in pattern. The 24 hour clock, with midnight starting at 24:00.</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>These examples will show you how to add hour cycle data to your {{jsxref("Locale", "Locale")}} object.</p>

<h3 id="Adding_an_hour_cycle_via_the_locale_string">Adding an hour cycle via the locale string</h3>

<p>In the <a href="https://www.unicode.org/reports/tr35/" rel="noopener">Unicode locale string spec</a>, the hour cycle is a locale string "extension subtag". These subtags add additional data about the locale, and are added to locale identifiers by using the <code>-u</code> extension key. Thus, the hour cycle type can be added to the inital locale identifier string that is passed into the {{jsxref("Locale/Locale", "Locale")}} constructor. To add the hour cycle type, first add the <code>-u</code> extension key to the string. Next, add the <code>-hc</code> extension key to indicate that you are adding an hour cycle. Finally, add the hour cycle type to the string.</p>

<pre class="brush: js">let fr24hour = new Intl.Locale("fr-FR-u-hc-h23");
console.log(fr24hour.hourCycle); // Prints "h23"</pre>

<h3 id="Adding_an_hour_cycle_via_the_configuration_object_argument">Adding an hour cycle via the configuration object argument</h3>

<p>The {{jsxref("Locale/Locale", "Intl.Locale")}} constructor has an optional configuration object argument, which can contain any of several extension types, including hour cycle types. Set the <code>hourCycle</code> property of the configuration object to your desired hour cycle type, and then pass it into the constructor.</p>

<pre class="brush: js">let us12hour = new Intl.Locale("en-US", {hourCycle: "h12"});
console.log(us12hour.hourCycle); // Prints "h12"</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ES Int Draft', '#sec-Intl.Locale.prototype.hourCycle')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("javascript.builtins.Intl.Locale.hourCycle")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Locale", "Intl.Locale")}}</li>
 <li><a href="https://www.unicode.org/reports/tr35/#UnicodeHourCycleIdentifier">Unicode Hour Cycle extension key spec</a></li>
</ul>
